unit Unit1;

//Programme par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, Menus, ImgList, ExtCtrls;

const wm_AppelMessage=wm_user+1;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Quitter1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Dclarations prives }
    i:Integer;
     procedure WMAppelMessage(var msg : TMessage); message wm_AppelMessage;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  tray:TNotifyIconData;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
tray.cbSize:=sizeof(tray);
tray.wnd:=handle;
tray.uID:=1;
tray.UCallbackMessage:=wm_AppelMessage;
tray.hIcon:=Application.Icon.handle; //Choix de l'icone
tray.szTip:='Cliquez pour quitter'; //Choix du message
tray.uFlags:=nif_message or nif_icon or nif_tip;
Shell_NotifyIcon(Nim_ADD,@tray);
i:=0;
end;

procedure TForm1.WMAppelMessage(var msg : TMessage);
begin
//clique droit de la souris
if msg.LParam=Wm_LButtonDown then
Close; //Quitte l'application
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Shell_NotifyIcon(Nim_DELETE,@tray); //Supprime le tray icon
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
Close; //Ferme la fiche
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Icon: TIcon;
begin
Inc(i); //Incremente la variable i
if i=2 then i:=0; //Alterne 0 et 1 (pour le choix de l'icne)
Icon:=TIcon.Create;
try
ImageList1.GetIcon(i,Icon); //Choix de l'icone
tray.hIcon:=Icon.Handle;
Shell_NotifyIcon(Nim_Modify,@tray); //Modife l'icne du Tray Icons
finally
Icon.Free;
end;
end;

end.
